#include <iostream>
#include <vector>
#include <algorithm>
#include <limits.h>
#include <boost/foreach.hpp>

//
// Computing the hamming numbers in linear time.
// 

int main(){

  typedef unsigned long long Num;
  typedef std::vector<Num> Nums;
  typedef std::vector<Num>::const_iterator Nums_const_iterator;

  Nums result;
  Num last, prod, i, j, z, max_num, end_n2, end_n3, end_n5, end_n23;
  
  max_num = ULLONG_MAX;
  //max_num = 100;

  
  // checks with "last" are due to need to avoid overflow, 
  //
  for (last=1, i=2, j=0; i>last && i<max_num; last=i, i*=2, j++)// multiple 2
    result.push_back(i);
  end_n2 = j;
  
  for (last=1, i=3; i>last && i<max_num; last=i, i*=3, j++)  // multiple 3
    result.push_back(i);
  end_n3 = j;
    
  for (last=1, i=5; i>last && i<max_num; last=i, i*=5, j++)  // multiple 5
    result.push_back(i);
  end_n5 = j;
    
  for (i=0, z=j; i < end_n2; i++)  // 2^h * 3^k
    for (last=1, j=end_n2; j < end_n3; j++)
      if ((prod = result[i] * result[j])> last){
	
	result.push_back(prod);
	last = prod;
	z++;
      }
  end_n23 = z;

  for (i=0; i < end_n2; i++)       // 2^h * 5^k
    for (last=1, j=end_n3; j < end_n5; j++)
      if ((prod = result[i] * result[j]) > last){

	result.push_back(prod);
	last = prod;
      }      
  
  for (i=end_n2; i < end_n3; i++)  // 3^h * 5^k
    for (last=1, j=end_n3; j < end_n5; j++)
      if ((prod = result[i] * result[j]) > last){

	result.push_back(prod);
	last = prod;
      }      
  
  for (i=end_n5; i < end_n23; i++)  // 2^h * 3^k  (already computed)
    for (last=1, j=end_n3; j < end_n5; j++) // 5^z
      if ((prod = result[i] * result[j]) > last){

	result.push_back(prod);
	last = prod;
      }      

  // not actually need, just for my output 
  sort (result.begin(), result.end());
  
  BOOST_FOREACH(Nums::value_type x, result){
    std::cout << x << std::endl;
  }
  std::cout << "Size=" << result.size() << std::endl;
}
